#include "partition.h"
#include<bits/stdc++.h>
using namespace std;

const int MAXN = 2e8 + 5;
bool chetnost[MAXN], first[MAXN];
int pos[MAXN];

int power(int a, int b)
{
    int otg = 1;
    for(int i = 1; i <= b; i++)
    {
        otg *= a;
    }
    return otg;
}

bool is_pow2(int a)
{
    while(a % 2 == 0)
    {
        a /= 2;
    }
    if(a == 1)
    {
        return true;
    }
    else
    {
        return false;
    }
}

vector<int> solve(vector<int> A)
{
    for(int i = 0; i < A.size(); i++)
    {
        if(is_pow2(A[i]))
        {
            pos[A[i]] = i;
        }
        if(!chetnost[A[i]])
        {
            first[i] = true;
            chetnost[A[i]] = true;
        }
        else
        {
            chetnost[A[i]] = false;
        }
    }
    bool flag = false;
    for(int i = 25; i >= 1; i--)
    {
        int curr = power(2, i);
        if(chetnost[curr])
        {
            if(!flag)
            {
                first[pos[curr]] = true;
            }
            else
            {
                first[pos[curr]] = false;
            }
            flag = true;
        }

    }
    vector<int> otg;
    for(int i = 0; i < A.size(); i++)
    {
        if(first[i]) otg.push_back(i);
    }
    for(int i = 0; i < A.size(); i++)
    {
        if(!first[i]) otg.push_back(i);
    }
    return otg;
}
